// utils_cols.js
// algoritmo do trampolim, para a geração de valores inteiros aleatórios
function inteiro_aleatorio(
    p_min,
    p_max
){
    var amplitude = p_max - p_min + 1
    var salto = Math.random() * amplitude
    var destino = p_min + salto
    destino = Math.floor(destino)
    return destino
}//inteiro_aleatorio

// nosso primeiro algoritmo de procura
/*
será uma procura "linear" *e* "exaustiva"
linear - porque acontecerá elemento a elemento
exaustiva - porque iremos fazer NENHUMA optimização, procurando TODOS os elementos
 */
function procurar_na_col(
    p_where,
    p_what
)
{
    var onde_encontrei_what = []
    for(
        var idx=0;
        idx<p_where.length;
        idx+=1
    ){
        var el_do_momento = p_where[idx]
        var b_match_com_q_procuro = p_what == el_do_momento
        if(b_match_com_q_procuro) {
            // return true // optimização
            onde_encontrei_what.push(idx)
        }//if encontrei
    }//for todos os elementos
    return onde_encontrei_what
}//procurar_na_col

function col_aleatoria(
    p_min=1,
    p_max=100,
    p_quantidade=10,
    p_b_aceitar_repeticoes=true
){
    var amplitude = p_max - p_min +1
    var verificar_se_e_possivel = amplitude>=p_quantidade
        || p_b_aceitar_repeticoes==true

    if(!verificar_se_e_possivel){
        return "Impossível"
    }


    var col = []
    for(//var q=0;
        ; // notar que a zona de inicialização ficou vazia
        col.length<p_quantidade;
        //q+=1 // notar que a zona de atualização está vazia
    ){
        var v = inteiro_aleatorio(p_min, p_max)
        if(p_b_aceitar_repeticoes)
            col.push(v)
        else{
            // se não forem aceitáveis repetições
            // tem que entrar em ação um ALGORITMO DE PROCURA
            var b_valor_ja_existe = procurar_na_col(
                col,
                v
            ).length > 0
            if(!b_valor_ja_existe){
                col.push(v)
            }
        }
    }
    return col
}//col_aleatoria


function bs(col){
    var b_ordenada, b_trocas
    b_ordenada = false
    var penultimo_idx = col.length -1 -1

    while(!b_ordenada){
        for(
            var idx=0, b_trocas=false;
            idx<=penultimo_idx;
            idx+=1
        )
        {
            if(col[idx]>col[idx+1]){
                // trocar
                var temp = col[idx]
                col[idx] = col[idx+1]
                col[idx+1] = temp

                b_trocas = true
            }//if
        }//for

        if(!b_trocas) b_ordenada=true
    }//while
}//bs
